;
; quick and dirty TSR to disable VERIFY code in HP 95LX INT 13 BIOS
;	(to prevent crash bug in early HP 95LX's when someone does a
;	COPY /V or VERIFY ON.
;
; to make:
;	MASM i13fix;
;	LINK i13fix;
;	EXE2BIN i13fix i13fix.com
;

cseg	segment para public 'code'
	assume cs:cseg, ds:cseg

	org 100h

start:
	jmp	init


old13off	dw	?
old13seg	dw	?


myisr	proc	far

	cmp	ah,4			; function 4, VERIFY SECTORS?
	jnz	go_old			; jif no, jmp to old INT 13 vector

	xor	ah,ah			; return AH=0
	clc				;   and NC
	ret	2			; far return and trash flags on stack
go_old:
	jmp	dword ptr cs:old13off

myisr	endp

init:
	mov	ax,3513h		; get old int 13 vector
	int	21h

	mov	old13off,bx		; save old vector
	mov	old13seg,es

	lea	dx,myisr		; point int 13 to us
	mov	ax,2513h
	int	21h

	lea	dx,init			; throw away all from INIT on down
	add	dx,15			; round up to next even paragraph
	shr	dx,1			; turn byte count into paragraph count
	shr	dx,1
	shr	dx,1
	shr	dx,1
	mov	ax,3100h		; TSR
	int	21h
;
cseg	ends
	end	start
